require 'osx/cocoa'

class PlayerController < OSX::NSWindowController
	ib_outlets :qtMovieView, :trimInGroup, :trimInSlider, :trimOutGroup, :trimOutSlider

  def init
    initWithWindowNibName "Player"
  end

	def setMovie(movie, subclip, trimmers)
		# puts "hidden? #{trimmers.inspect}"
		# @trimInSlider.setEnabled(trimmers)
		# @trimOutSlider.setEnabled(trimmers)
		@qtMovieView.setMovie(movie)
		@subclip = subclip
	end
	
	def trim(sender)
		# puts "trim"
		# @new_in_point = @subclip[:in_point] + (@trimInSlider.floatValue.to_i * 1000)
		# @new_out_point = @subclip[:out_point] + (@trimOutSlider.floatValue.to_i * 1000)
		# # sanity check
		# puts @new_in_point, @new_out_point
		# if @new_in_point < 0
		# 	@new_in_point = 0
		# 	@trimInSlider.setFloatValue(0)
		# end
		# media_out_point = (@subclip[:duration].to_f * 1000 / @subclip[:timebase].to_f)
		# if @new_out_point > media_out_point || @new_out_point < @new_in_point
		# 	@new_out_point = media_out_point
		# 	@trimOutSlider.setFloatValue(0)
		# end
		# qt_movie, error = OSX::QTMovie.movieWithFile_error(@subclip[:pathurl])
		# qtstart, qtduration = OSX::QTMakeTime(@new_in_point, 1000), OSX::QTMakeTime(@new_out_point - @new_in_point, 1000)
		# qt_subclip, error = qt_movie.movieWithTimeRange_error(OSX::QTMakeTimeRange(qtstart, qtduration))
		# unless qt_subclip==nil || error!=nil
		# 	@qtMovieView.setMovie(qt_subclip)
		# 	qt_subclip.play
		# end
	end
	ib_action :trim
	
	# PlayerController has been made the delegate for the window
	def windowWillClose(notification)
		@qtMovieView.movie.stop
		@qtMovieView.setMovie(nil)
		# update in and out points
		# @subclip[:in_point] = @new_in_point unless @new_in_point.nil?
		# @subclip[:out_point] = @new_out_point unless @new_out_point.nil?
	end

end
